package org.jeecg.modules.orderplatform.entity;

import java.util.Date;

import cn.com.ctop.common.module.annotation.Dict;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;

/**
 * 物料审批流程
 */
@Data
@TableName("ctop_platform_material")
public class PlatformMaterial {
    
	/**id*/
	@TableId(type = IdType.AUTO)
	private Long id;

	/**orderCode*/
	private String orderCode;

	/**关联项目*/
	private Long projectId;

	@TableField(exist = false)
	private String projectName;

	/**物料唯一标识*/
	private String materialCode;

	/**物料名*/
	private String materialName;

	/**materialType*/
	private Integer materialType;

	/**materialStatus*/
	private Integer materialStatus;

	/**脚本id*/
	private String scriptId;

	/**脚本审批状态*/
	private Integer scriptStatus;

	/**审批建议*/
	private String scriptAdvise;

	/**脚本上传人*/
	private String scriptCreator;

	/**脚本创建时间*/
	private Date scriptCreateTime;

	/**编导*/
	@Dict(dicCode = "id",dictTable="sys_user",dicText="realname")
	private String plan;

	@TableField(exist = false)
	private String planName;

	/**视频id*/
	private String videoId;

	/**视频审批状态*/
	private Integer videoStatus;

	/**视频审批建议*/
	private String videoAdvise;

	/**视频上传人*/
	private String videoCreator;

	/**视频创建时间*/
	private Date videoCreateTime;

	/**视频拍摄*/
	@Dict(dicCode = "id",dictTable="sys_user",dicText="realname")
	private String shot;

	@TableField(exist = false)
	private String shotName;

	/**视频剪辑*/
	@Dict(dicCode = "id",dictTable="sys_user",dicText="realname")
	private String clip;

	@TableField(exist = false)
	private String clipName;

	public PlatformMaterial() {
	}

	public PlatformMaterial(String plan, String shot, String clip) {
		this.plan = plan;
		this.shot = shot;
		this.clip = clip;
	}
}
