package cn.com.ctop.kuaishou.modules.batch.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * @Description: 广告组信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_group")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_group对象", description = "广告组信息")
public class KuaiShouGroup {

    /**
     * id
     */
    @TableId
    private String id;
    /**
     * 账户ID
     */
    private Long accountId;
    /**
     * 广告活动ID
     */
    private Long campaignId;

    @TableField(exist = false)
    private String campaignName;
    /**
     * 广告组ID
     */
    private Long unitId;
    /**
     * 广告组名称
     */
    private String unitName;
    /**
     * 广告组状态
     */
    private Integer status;
    private Integer putStatus;
    private Integer studyStatus;
    private Integer createChannel;
    /**
     * 审核拒绝理由
     */
    private String reviewDetail;
    /**
     * 出价类型
     */
    private Integer bidType;
    /**
     * 出价
     */
    private Long bid;
    /**
     * OCPC出价
     */
    private Long cpaBid;

    private Integer deepConversionType;
    private Long deepConversionBid;

    /**
     * OCPX行为类型   1： CPM， 2： CPC，
     */
    private Integer ocpxActionType;
    /**
     * 单日预算
     */
    private Long dayBudget;
    /**
     * 投放方式  0：未知， 1：正常投
     */
    private Integer speed;
    /**
     * 投放开始时间
     */
    private String beginTime;
    /**
     * 投放结束时间
     */
    private String endTime;
    private String scheduleTime;
    private String sceneId;

    /**
     * 创意展现方式  0：未知， 1：轮播，
     */
    private Integer showMode;
    private Integer unitType;
    /**
     * url类型
     */
    private Integer urlType;
    /**
     * 落地页链接
     */
    private Object url;
    private String schemaUri;
    /**
     * APP ID
     */
    private Long appId;
    /**
     * APP图标存储地址
     */
    private String appIconUrl;


    // 转化目标
    private Long convertId;
    // 转化目标
    private Integer useAppMarket;
    private String groupCreateTime;
    private String groupUpdateTime;

    // 应用商店列表
    private String appStore;


    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 修改时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private KuaiShouGroupTarget target;

}
